package com.wangzhengzhen.demo.proxy;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class TransPortData implements Runnable {

	private static int BUFFER_SIZE = 10240;
	
	private Socket getDataSocket;
	private Socket putDataSocket;

	public TransPortData(Socket getDataSocket, Socket putDataSocket) {
		this.getDataSocket = getDataSocket;
		this.putDataSocket = putDataSocket;
	}

	@Override
	public void run() {
		try {
			while (true) {

				InputStream in = getDataSocket.getInputStream();
				OutputStream out = putDataSocket.getOutputStream();
				// 读入数据
				byte[] data = new byte[BUFFER_SIZE];
				int readlen = in.read(data);

				// 如果没有数据，则暂停
				if (readlen <= 0) {
					Thread.sleep(300);
					continue;
				}

				out.write(data, 0, readlen);
				out.flush();
			}
		} catch (Exception e) {
			
		} finally {
			// 关闭socket
			try {
				if (putDataSocket != null) {
					putDataSocket.close();
				}
			} catch (Exception exx) {
			}

			try {
				if (getDataSocket != null) {
					getDataSocket.close();
				}
			} catch (Exception exx) {
			}
		}
	}

}
